/*
** Header for iface.c
**
** Copyright (C) 2004  Moreno 'baro' Baricevic
**                                      <baro AT democritos DOT it>
**
** This  file may be used subject to the terms and conditions of the
** GNU Library General Public License as published by the Free Soft-
** ware Foundation; either version 2 of the License, or (at your op-
** tion) any later version.
**
** This file is distributed in the hope that it will be useful,  but
** WITHOUT  ANY  WARRANTY; without even the implied warranty of MER-
** CHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Li-
** brary General Public License for more details.
*/

/**************************************************
 * Author: Moreno 'baro' Baricevic                *
 * Date:   04 May 2004                            *
 * Title:  iface.h                                *
 *================================================*
 * Last Modified: 04 May 2004                     *
 **************************************************/

#ifndef _IFACE_H_
#define _IFACE_H_


#include <sys/ioctl.h>		// ioctl
#include <netinet/in.h>		// sockaddr_in
#include <net/if.h>		// if_nameindex, if_freenameindex
#include <linux/sockios.h>	// SIOCGIFADDR, SIOCGIFHWADDR


#ifndef SIOCGIFADDR
# error SIOCGIFADDR unsupported by kernel!
#endif
#ifndef SIOCGIFHWADDR
# error SIOCGIFHWADDR unsupported by kernel!
#endif


/**************************************************************
** Display an IP address in readable format (include/linux/kernel.h)
*/

/* address must be in network byte order */
#define NIPQUAD(addr) \
        ((unsigned char *)&addr)[0], \
        ((unsigned char *)&addr)[1], \
        ((unsigned char *)&addr)[2], \
        ((unsigned char *)&addr)[3]


#define MAC_LEN 17+1
#define IP_LEN	15+1
#define	IPX_LEN	 8+1

typedef struct {
   char iface [ IF_NAMESIZE ] ;
   char mac   [ MAC_LEN     ] ;
   char ip    [ IP_LEN      ] ;
   char ipx   [ IPX_LEN     ] ;
} if_s ;


#define SEP_CH		' '
#define EMPTY_CH	'-'


extern int get_iface_info ( int sock , const char * iface , if_s * buf );


#endif /* _IFACE_H_ */




/***********************  E N D   O F   F I L E  ************************/

